routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
  |--------------------------------------------------------------------------
  | Web Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register web routes for your application. These
  | routes are loaded by the RouteServiceProvider within a group which
  | contains the "web" middleware group. Now create something great!
  |
 */
Auth::routes();

Route::get('/', 'HomeController@index')->name('home.index');
Route::get('/registerc', 'Auth\RegisterController@registerc')->name('register.registerc');
//Route::resource('users', 'UserController')->middleware('auth');
//Route::get('categoriasu', 'CategoriasUserController@index');

Route::get('recuperarpassword/{hash}', 'Auth\ResetPasswordController@resetpassword')->name('user.resetpassword');
Route::post('enviarlink/password', 'Auth\ResetPasswordController@resetpasswordhash')->name('usuario.sendlinkpassword');
Route::post('actualizar/password', 'Auth\ResetPasswordController@updatepassword')->name('usuario.updatepassword');

Route::middleware(['auth'])->group(function () {

    /* Route::get('inicio', function () {
      return view('welcome');
      })->name('inicio'); */

    Route::resource('users', 'UserController'); //CRUD
    Route::resource('categoriasu', 'CategoriasUserController'); //CRUD s
    Route::resource('productos', 'ProductoController'); //CRUD
    Route::resource('links', 'LinkController'); //CRUD

    Route::post('productos/{producto}/duplicate', 'ProductoController@duplicate')->name('productos.duplicate');

    Route::post('productos/{producto}/linkear', 'ProductoController@linkear')->name('productos.linkear');

    Route::resource('configuracion', 'ConfiguracionController'); //CRUD

    Route::get('cargamasiva', 'CargaMasivaController@index')->name('cargamasiva.index');
    Route::get('cargamasiva/plantilla', 'CargaMasivaController@downloadtemplate')->name('cargamasiva.template');
    Route::post('cargamasiva/procesar', 'CargaMasivaController@process')->name('cargamasiva.proccess');

    Route::get('cargamasiva/users', 'CargaMasivaController@indexusers')->name('userscargamasiva.index');
    Route::get('cargamasiva/plantilla/usuarios', 'CargaMasivaController@downloadtemplateusers')->name('cargamasivausers.template');
    Route::post('cargamasiva/procesar/usuarios', 'CargaMasivaController@processusers')->name('cargamasivausers.proccess');

    Route::get('soporte/create', 'SoporteController@create')->name('soporte.create');
    Route::post('soporte/create/process', 'SoporteController@createprocess')->name('soporte.createprocess');

    Route::get('datosbancarios', 'DatosBancariosController@create')->name('datosbancarios.create');
    Route::post('datosbancarios/create/procesar', 'DatosBancariosController@createprocess')->name('datosbancarios.createprocess');
    Route::get('datosbancarios/{users}', 'DatosBancariosController@show')->name('datosbancarios.show');

    //Route::get('users', 'UserController@linkpago')->name('users.linkpago');

    Route::get('perfil/edit', 'PerfilController@edit')->name('perfil.edit');
    Route::post('perfil/edit/process', 'PerfilController@editprocess')->name('perfil.editprocess');

    Route::post('perfil/edit/setshopify', 'PerfilController@setshopify')->name('perfil.setshopify');

    Route::post('users/{user}/updateurl', 'UserController@updateurl')->name('users.updateurl');

    Route::get('pagos/', 'PagosController@index')->name('pagos.index');
    Route::post('pagos/spa', 'PagosController@spa')->name('pagos.spa');
    Route::post('pagos/spl', 'PagosController@spl')->name('pagos.spl');
    Route::get('pagos/{pagos}/edit', 'PagosController@edit')->name('pagos.edit');
    Route::put('pagos/{pagos}/update', 'PagosController@update')->name('pagos.update');
    //Route::get('categoriasComercios/{cc}', 'CategoriasUserController@show')->name('categoriasComercios');

    Route::post('categoriaproducto/create', 'CategoriascController@create')->name('categoriaproductos.create');
    Route::post('categoriaproducto/eliminar', 'CategoriascController@eliminar')->name('categoriaproductos.delete');
});

//Route::resource('users', 'UserController');
//Route::get('users','UserController@index');
//Route::post('users','UserController@store')->name('users.store');
//Route::delete('users/{user}','UserController@destroy')->name('users.destroy');

app/Pagos.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;

class Pagos extends Model
{
    //
    protected $fillable = ['codigo_pago', 'users_id', 'links_id', 'productos_id', 'comision_afiliado','comision_admin','estado_comerciante','estado_afiliado']; 

    protected $hidden = [];

    public function users()
    {
        return $this->belongsTo(User::class, 'users_id');
    }

    public function producto()
    {
        $producto = $this->belongsTo(Productos::class, 'productos_id');
        if($producto)
            return $producto;
        else   
            return 'Producto Eliminado';
    }

    public function getNombreusuarioAttribute()  
    {
        $producto = Productos::
        where('id', '=', $this->productos_id)
        ->first();

        if($producto) {
            return $producto->users_id;
        } else { 
            return 'N/A'; 
        }
    }

    public function getProductoNombreAttribute()
    {
        $db = Productos::
        where('id', '=', $this->productos_id)
        ->first(); 

        if($db)
            return $db->nombre_p;
        else   
            return 'Producto Eliminado';
    }

    public function getTipoAttribute()
    {
        $db = CategoriasComercios::
        where('id', '=', $this->users->cc_id)
        ->first(); 

        return $db->nombre_cc; 
    }

    public function getFormatFechaAttribute() {
        return $this->created_at->format('d M Y');
    }

    public function getEstadoAfiliadoDinamicoAttribute() {
        switch($this->estado_afiliado){
            case 'E':
                $nombre = 'Espera';
            break;
            case 'EA':
                $nombre = 'Espera Ad';
            break;
            case 'R':
                $nombre = 'Rechazado';
            break;
            case 'C':
                $nombre = 'Completado';
            break;
        }

        return '<div class="box-estado box-'.$this->estado_afiliado.'">
                    <div style="display:block">'.$nombre.'</div>
                </div>';
    }

    public function getEstadoComercioDinamicoAttribute() {
        switch($this->estado_comerciante){
            case 'E':
                $nombre = 'Espera';
            break;
            case 'EA':
                $nombre = 'Espera Ad';
            break;
            case 'R':
                $nombre = 'Rechazado';
            break;
            case 'C':
                $nombre = 'Completado';
            break;
        }

        return '<div class="box-estado box-'.$this->estado_comerciante.'">
                    <div style="display:block">'.$nombre.'</div>
                </div>';
    }

    public function getEstadosPagosAttribute() {
        $estados = [
            'E' => 'Espera',
            'EA' => 'Espera Admin',
            'R' => 'Rechazado',
            'C' => 'Completado'
        ];

        return $estados;    
    }    

    public function sumaTotal()
    {
        return  $this->comision_admin + $this->comision_afiliado; 
    }
}

app/Http/Controllers/ProductoController.php
<?php

namespace App\Http\Controllers;

use App\Productos;
use App\CategoriasProductos;
use App\FotosProductos;
use App\Links;
use App\User;
//use Illuminate\Http\Request;
use App\Http\Requests\ProductosRequest;

use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;

class ProductoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {   
        //$name = $request->input('search');
        //dd($name);

        $cc = CategoriasProductos::
        //->where('id', '>=', '20')
        orderBy('id','DESC')
        //->take()
        ->get();

        if(Auth::user()->cc_id == 1) {// si es un comerciante
            
            $productos = Productos::query();
            $productos->where('users_id', '=', Auth::user()->id);
            
            if (!empty($request->input('search'))) {

                $comercio = User::
                where([
                    ['name', 'LIKE', $request->input('search').'%'], 
                    ['cc_id', '=', 1] 
                ])
                ->first();

                if($comercio){
                    $productos->where('users_id', '=', $comercio->id);  
                } else {                            
                    if(is_numeric($request->input('search')))
                        $productos->where('id', '=', $request->input('search'));  
                    else
                        $productos->where('nombre_p', 'LIKE', $request->input('search').'%');  
                }
            }                
                
            if (!empty($request->input('cp_id')))
                $productos->where('cp_id', '=', $request->input('cp_id'));  

            if (!empty($request->input('porcentaje_a')))
                $productos->where('porcentaje_a', '=', $request->input('porcentaje_a'));
                
            if ($request->input('valor'))
                $productos->whereBetween('productos.valor', [ $request->input('valor_i'), $request->input('valor_f') ]);
    
            if (!empty($request->input('orden_p')))
                $productos->orderBy('id', $request->input('orden_p'));
            else
                $productos->orderBy('id','DESC');

            $view = $productos->paginate(10);

            return view('productos.comerciante.index', ['productos' => $view, 'cc' => $cc ]);   

        } else if(Auth::user()->cc_id == 2) { //afiliado  

            $productos = Productos::query();
            //$productos->where('users_id', '=', Auth::user()->id);
            
            if (!empty($request->input('search'))) {

                $comercio = User::
                where([
                    ['name', 'LIKE', $request->input('search').'%'], 
                    ['cc_id', '=', 1] 
                ])
                ->first();

                if($comercio){
                    $productos->where('users_id', '=', $comercio->id);  
                } else {                            
                    if(is_numeric($request->input('search')))
                        $productos->where('id', '=', $request->input('search'));  
                    else
                        $productos->where('nombre_p', 'LIKE', $request->input('search').'%');  
                }
            }                  
                
            if (!empty($request->input('cp_id')))
                $productos->where('cp_id', '=', $request->input('cp_id'));  

            if (!empty($request->input('porcentaje_a')))
                $productos->where('porcentaje_a', '=', $request->input('porcentaje_a'));
                
            if ($request->input('valor'))
                $productos->whereBetween('valor', [$request->input('valor_i'), $request->input('valor_f') ]);
    
            if (!empty($request->input('orden_p')))
                $productos->orderBy('id', $request->input('orden_p'));
            else
                $productos->orderBy('id','DESC');

            $view = $productos->paginate(10);

            return view('productos.afiliado.index', ['productos' => $view, 'cc' => $cc ]);   

        } else {    

            /*if(!empty($request->input('search')))
                $productos = Productos::
                where('nombre_p','LIKE', $request->input('search').'%')
                ->orderBy('id','DESC')
                ->get();
            else     
                $productos = Productos::
                orderBy('id','DESC')
                ->get();  */

            $productos = Productos::query();
            //$productos->where('users_id', '=', Auth::user()->id);                        
            
            if (!empty($request->input('search'))) {

                $comercio = User::
                where([
                    ['name', 'LIKE', $request->input('search').'%'], 
                    ['cc_id', '=', 1] 
                ])
                ->first();

                if($comercio){
                    $productos->where('users_id', '=', $comercio->id);  
                } else {                            
                    if(is_numeric($request->input('search')))
                        $productos->where('id', '=', $request->input('search'));  
                    else
                        $productos->where('nombre_p', 'LIKE', $request->input('search').'%');  
                }
            }        

            $view = $productos->get();

            return view('productos.index', ['productos' => $view, 'cc' => $cc ]);
        }            
        //dd(Auth::user()->cc_id);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $cc = CategoriasProductos::
        //->where('id', '>=', '20')
        orderBy('id','DESC')
        //->take()
        ->get();

        if(Auth::user()->cc_id == 3) //si es un admin
            return view('productos.create', [ 'cc' => $cc ]);
        else
            return view('productos.comerciante.create', [ 'cc' => $cc ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductosRequest $request)
    {       
        $producto = Productos::create($request->all() + ['codigo' => 1, 'tipo' => 'ADMIN', 'users_id' => $request->user()->id ]);        
        
        foreach($request->file('url_imagen') as $img) {
            FotosProductos::create([
                'productos_id' => $producto->id,
                'url_imagen' => $img->store('productos', 'public')
            ]);
        }

        return back()->with('status', 'Creado con éxito.');
    }

   
    /**
     * Display the specified resource.
     *
     * @param  \App\Productos  $productos
     * @return \Illuminate\Http\Response
     */
    public function show(Productos $producto)
    {
        //dd($producto);

        return view('productos.afiliado.view', ['producto' => $producto]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Productos  $productos
     * @return \Illuminate\Http\Response
     */
    public function edit(Productos $producto)
    {
        //
        $cc = CategoriasProductos::
        //->where('id', '>=', '20')
        orderBy('id','DESC')
        //->take()
        ->get();

        if(Auth::user()->cc_id == 3) //si es un admin
            return view('productos.edit', [ 'producto' => $producto, 'cc' => $cc ]);
        else
            return view('productos.comerciante.edit', [ 'producto' => $producto, 'cc' => $cc ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Productos  $productos
     * @return \Illuminate\Http\Response
     */
    public function update(ProductosRequest $request, Productos $producto)
    {
        //
        //dd($request);

        $producto->update($request->all());

        /*foreach($producto->productofotos as $item) {
            Storage::disk('public')->delete($item->url_imagen);
        }*/      

        FotosProductos::where('productos_id', $producto->id)->delete();

        if(is_array($request->url_imagen_old)) {
            foreach($request->url_imagen_old as $img) {
                FotosProductos::create([
                    'productos_id' => $producto->id,
                    'url_imagen' => $img
                ]);
            }
        }

        if($request->file('url_imagen')) {
            foreach($request->file('url_imagen') as $img) {
                FotosProductos::create([
                    'productos_id' => $producto->id,
                    'url_imagen' => $img->store('productos', 'public')
                ]);
            }
        }

        return back()->with('status', 'Actualizado con éxito.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Productos  $productos
     * @return \Illuminate\Http\Response
     */
    public function destroy(Productos $producto)
    {
        //
        if($producto->productofotos) {
            foreach($producto->productofotos as $item) {
                Storage::disk('public')->delete($item->url_imagen);
            }       

            FotosProductos::where('productos_id', $producto->id)->delete();
        }

        $producto->delete();

        return redirect()->route('productos.index')->with('status', 'Se elimino producto con éxito.');  
    }

    public function duplicate(Productos $producto)
    {
        //dd($producto->productofotos);   
        
        $duplicado = Productos::create([
            'users_id' => Auth::user()->id,
            'codigo' => 1,
            'nombre_p' => $producto['nombre_p'],
            'web' => $producto['web'],

resources/views/productos/comerciante/edit.blade.php
@extends('layout') 
@section('content')
<div class="row page-titles">
    <div class="col-md-5 align-self-center">
        <h3 class="text-themecolor">Editar Producto</h3>
    </div>
    <div class="col-md-7 align-self-center">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('productos.index')}}">Productos</a></li>
            <li class="breadcrumb-item active">Editar Producto</li>
        </ol>
    </div>
    <div>
        <button class="right-side-toggle waves-effect waves-light btn-inverse btn btn-circle btn-sm pull-right m-l-10"><i class="ti-settings text-white"></i></button>
    </div>
</div>

<div class="container-fluid">   

    @if($errors->any())
    <div class="card border-0 shadow">
        <div class="card-body">
            <div class="alert alert-danger">
                @foreach($errors->all() as $error)
                - {{ $error }} <br/>
                @endforeach
            </div>
        </div>
    </div>
    @endif

    <div class="row"> 
        <div class="col-lg-12">
            <form action="{{ route('productos.update', $producto) }}" method="POST" class="form-horizontal form-producto" enctype="multipart/form-data">
                @csrf
                @method('PUT')
                <div class="card card-outline-info">
                    <div class="card-body">
                        <div class="form-body">
                            <h6 class="box-title">Ingrese los siguiente datos</h6>
                            <hr class="m-t-0 m-b-40">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Nombre</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="nombre_p" value="{{ old('nombre_p', $producto->nombre_p) }}" required>
                                            
                                        </div>
                                    </div> 
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Categoria</label>
                                        <div class="col-md-8">
                                            <select class="form-control custom-select" name="cp_id" required>
                                                @foreach($cc as $item)
                                                <option value="{{$item->id}}" @if( $item->idcp == old('cp_id') || $item->id == $producto->cp_id) {!! _('selected') !!} @endif >{{$item->nombre_cp}}</option>
                                                @endforeach
                                            </select>
                                        </div>
                                    </div> 
                                    <!--
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Sitio Web</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="web" value="{{ old('web', $producto->web) }}" required>
                                        </div>
                                    </div>
                                    -->
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Link</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="url_web" value="{{ old('url_web', $producto->url_web) }}" required>
                                        </div>
                                    </div> 
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">SKU</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="sku" value="{{ old('sku', $producto->sku) }}" required>                                           
                                        </div>
                                    </div>      
                                    <div class="form-group row m-b-10">
                                        <label class="control-label text-right col-md-4">Descripción</label>
                                        <div class="col-md-8">
                                            <textarea rows="5" class="form-control" name="descripcion" style="height: 80px;">{{ old('descripcion', $producto->descripcion) }}</textarea>
                                        </div>
                                    </div>                                                 
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Porcentaje Afiliado</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="porcentaje_a" value="{{ old('porcentaje_a', $producto->porcentaje_a) }}" required>  
                                        </div>
                                    </div>                                                     

                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Img.Perfil</label>
                                        <div class="col-md-8">
                                            <div class="content-fotos row">

                                                @foreach($producto->productofotos as $index => $foto)
                                                <div class="col-3 block_{{$index}}" style="display: block">
                                                    <i class="fa fa-trash" onclick="delImage({{$index}})"></i>
                                                    @if($foto->tipo == 'IN')
                                                    <img class="previoFondo m-b-5" style="width: 100%;" src="{{url('storage/app/public/'.$foto->url_imagen)}}">

                                                    <input type="hidden" name="url_imagen_old[]" value="{{$foto->url_imagen}}"/>
                                                    @else
                                                    <img class="previoFondo m-b-5" style="width: 100%;" src="{{$foto->url_imagen}}">

                                                    <input type="hidden" name="url_imagen_old[]" value="{{$foto->url_imagen}}"/>
                                                    @endif
                                                </div>
                                                @endforeach

                                                <div class="col-3" style="display:block">
                                                    <div class="file-field addFile">
                                                        <div class="btn btn-photo btn-sm">
                                                            <i class="fa-camera fa"></i>
                                                        </div>
                                                    </div>          
                                                </div>
                                            </div>                 
                                        </div>
                                    </div>    
                                    
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Valor</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="valor" value="{{ old('valor', $producto->valor) }}" required>                                            
                                        </div>
                                    </div> 

                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Conversión</label>
                                        <div class="col-md-8">
                                            <select class="form-control custom-select" name="conversion" required>
                                                <option value="venta">VENTA</option>
                                                <option value="pagina llegada">PAGINA LLEGADA</option>
                                            </select>
                                        </div>
                                    </div> 
                                </div>
                            </div>   
                        </div>                        
                    </div>
                </div>
                <div class="form-actions">
                    <div class="row">
                        <div class="col-md-12">                            
                            <a href="{{route('productos.index')}}" class="btn-md btn-inverse float-right">Cancelar</a>
                            <button type="button" class="btn-md btn-primary float-right m-r-10 btn-form">Guardar</button>
                        </div>
                    </div>
                </div>
            </form>

            <div class="form-actions">
                <div class="row">
                    <div class="col-md-3">  
                        <form method="POST" action="{{ route('productos.destroy', $producto) }}">
                            @method('DELETE')
                            @csrf
                            <button type="submit" value="Eliminar" class="btn-md btn-danger float-left" onclick="return confirm('¿Desea eliminar..?')">Eliminar</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).ready(function() {       
        var cont = {{count($producto->productofotos)}};
        $('.addFile').on('click', ()=>{
            var htmlimg = '<div class="col-3 block_'+cont+'"><i class="fa fa-trash" onclick="delImage('+cont+')"></i><img class="previoFondo m-b-5" style="width: 100%;"><input type="file" class="form-control imgFondo" name="url_imagen[]" data-cont="'+cont+'" onChange="readURL(this, '+cont+')"></div>';

            $( htmlimg ).prependTo( ".content-fotos" );
            $( ".block_"+cont+" [type='file']" ).trigger( "click" );
            cont++;
        });        
    });

    function readURL(input, doom) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();                
            reader.onload = function (e) {                   
                $('.block_'+doom+' .previoFondo').attr('src', e.target.result).show();
                $('.block_'+doom).show();
            }
            reader.readAsDataURL(input.files[0]);
            //$('.'+doom).val(input.files[0].name);             
        }
    }

    function delImage(doom) {
        $('.block_'+doom).remove();
    }

    var btnSubmit = document.querySelector(".btn-form");
    btnSubmit.onclick = () => {
        var images = document.querySelectorAll(".previoFondo");
        if(images.length == 0){
            Swal.fire({
                icon: 'error',
                title: 'Oops...',
                text: 'Se requiere una foto del producto.'
            });
            return false;
        }
        var form = document.querySelector(".form-producto");
        form.submit();
    };
</script>

<style>
    .content-fotos .addFile i {
        position: relative !important;
        top: 0 !important;
        right: 0 !important;
        color: #432874 !important;
    }
    .content-fotos .col-3 {
        margin: 0;
        padding: 0;
        margin-right: 5px;
        overflow: hidden;
        display: none;
    }
    .content-fotos i {
        position: absolute;
        right: 5px;
        top: 5px;
        color: white;
    }
    input[type="file"] {
        position: absolute;
        top: 0;
        right: 0;
        bottom: 0;
        left: 0;
        width: 100%;
        padding: 0;
        margin: 0;
        cursor: pointer;
        filter: alpha(opacity=0);
        opacity: 0;
        display:none;
    }
</style>

@endsection